#include <windows.h>
#pragma	hdrstop
#include	"rexpgen.h"
#ifdef _UNICODE
#include "bocu1.h"
#include "utf.h"
#endif

GenericRexp::GenericRexp( )
{
	srchflag = 0;
#ifdef _UNICODE
	Buffer = NULL;
	BufferLen = 0;
#endif

	next = NULL;
	connection = 0;
	not = false;
}
GenericRexp::~GenericRexp( )
{
#ifdef _UNICODE
	if (Buffer)
		delete[] Buffer;
#endif
	if (next)
		delete next;
}
BOOL GenericRexp::Compile(const tchar *str)
{
	pattern = str;
	return Compile();
}
BOOL GenericRexp::Compile( )
{
	GenericRexp *rexp = this;
	for(;;){
		BOOL r = rexp->CompileImpl(rexp->pattern);
		if (!r)
			return FALSE;
		if (!rexp->next)
			return r;
		rexp = rexp->next;
	}
}
// If matches is not null, get the full match info. (speed slower)
//TODO: Not include the match information of the all of the words.
BOOL GenericRexp::Compare( const tchar *str, TMatchInfos *matches )
{
	GenericRexp *rexp = this;
	BOOL ret = FALSE;
	for(;;){
		rexp->matched = false;
		BOOL r = rexp->CompareImpl(str);
		if (rexp->not)
			r = !r;
		if (matches && !rexp->not){
			//Note: not include the match info of the not operation.
			if (r){
				int loc, len;
				rexp->GetMatchImpl(len, loc);
				matches->add(new TRexpMatchInfo(loc, len));
			}
		}
		if (!rexp->next){
			return rexp->matched = (r || ret);
		}
		if (rexp->next->connection==0){
			// AND
			if (!r){
				return FALSE;
			}
		} else {
			// OR
			if (r){
				rexp->matched = true;
				if (!matches){
					return TRUE;
				}
				ret = TRUE;
			}
		}
		rexp = rexp->next;
	}
}
BOOL GenericRexp::GetMatch( int &len, int &loc )	// len : }b` loc : }b`ʒu
{
	GenericRexp *rexp = this;
	for(;;){
		if (rexp->matched){
			BOOL r = rexp->GetMatchImpl(len, loc);
			if (r)
				return TRUE;
		}
		if (!rexp->next){
			return FALSE;
		}
		rexp = rexp->next;
	}
}

void GenericRexp::SetFlag( int flag, BOOL f )
{
	if ( f ){
		srchflag |= flag;
	} else {
		srchflag &= ~flag;
	}
}
#ifdef _UNICODE
bool GenericRexp::CompareBocu1( const char *s, FNPreCodeTranslate precode )
{
	int slen = strlen(s);
	int maxlength = (slen<<2)+1;
	if (BufferLen < maxlength ){
		BufferLen = maxlength;
		if (Buffer) delete[] Buffer;
		Buffer = new wchar_t[BufferLen];
	}
	bocu1Decode( &(const unsigned char*)s, (const unsigned char*)(s)+slen, maxlength, Buffer, NULL, precode );
	return Compare(Buffer);
}
bool GenericRexp::CompareUTF8( const char *s )	// for UTF-8
{
	int slen = strlen(s);
	int maxlength = (slen<<1)+1;
	if (BufferLen < maxlength ){
		BufferLen = maxlength;
		if (Buffer) delete[] Buffer;
		Buffer = new wchar_t[BufferLen];
	}
	UTF8toUTF16( s, slen, Buffer );
	return Compare(Buffer);
}
#endif

