#ifndef	__REXPGEN_H
#define	__REXPGEN_H

#include "tndefs.h"
#include "tnstr.h"

#ifdef _UNICODE
#include "bocu1.h"
#endif

#define	GRXP_NORMAL			0x000
#define	GRXP_IGNORECASE		0x001
#define	GRXP_FUZZY			0x002
#define	GRXP_WORD			0x004
#define	GRXP_ZENHAN			0x008
#define	GRXP_HIRA			0x010
#define	GRXP_ZENHANHIRA		0x018

//	General Rexp

enum GenericRexpError {
	GRE_NORMAL = 0,
	GRE_NOTREADY,	// DLLpłȂ
	GRE_MEMORY,		// Ȃ
	GRE_TOOLONG,	// K\
	GRE_COMPLEX,	// K\G
	GRE_BRACKET,	// ʂ̑Ή
	GRE_CHARCLASS,	// LN^NXs
	GRE_ESCAPE,		// GXP[vV[PXłȂ
	GRE_SYNTAX,		// ǂ̕@Ɍ肪
	GRE_UNEXPECTED,	// \ȂG[i`G[j
	GRE_DLLBUG,		// oO̔
	GRE_APPBUG,		// AvP[ṼoO
	GRE_VERSION,	// o[WقȂ邽ߗpłȂ
	GRE_NOSTRINGS,	// 񂪂Ȃ
	GRE_STOP,		// ~
	GRE_NOREGULAR	// K\ߎsłȂ
};

struct TRexpMatchInfo {
	int loc;
	int len;
	TRexpMatchInfo(int _loc, int _len)
		:loc(_loc)
		,len(_len)
	{
	}
	TRexpMatchInfo(){}
};

typedef FlexObjectArray<TRexpMatchInfo> TMatchInfos;

class GenericRexp {
protected:
	tnstr pattern;
	bool matched;	// Ōcomparetrue/false?
public:
	int srchflag;	// ⏕tO
#ifdef _UNICODE
protected:
	wchar_t *Buffer;
	int BufferLen;
#endif
public:
	GenericRexp( );
	virtual ~GenericRexp( );

	virtual BOOL Open( ) = 0;
	virtual void Close( ) = 0;
	virtual BOOL CanUse( ) = 0;

	virtual BOOL Compile( );
	virtual BOOL Compile(const tchar *str);
	virtual BOOL Compare( const tchar *str, TMatchInfos *matches=0 );
	virtual BOOL GetMatch( int &len, int &loc );	// len : }b` loc : }b`ʒu

protected:
	virtual BOOL CompileImpl( const TCHAR *patern ) = 0;
	virtual BOOL CompareImpl( const TCHAR *str ) = 0;
	virtual BOOL GetMatchImpl( int &len, int &loc ) = 0;	// len : }b` loc : }b`ʒu

public:
	virtual int GetErrorCode( ) = 0;
	void SetFlag( int flag, BOOL f );
#ifdef _UNICODE
	bool CompareBocu1( const char *s, FNPreCodeTranslate );	// for BOCU1
	bool CompareUTF8( const char *s );	// for UTF-8
#endif
	void SetPattern(const tchar *_pattern)
		{ pattern = _pattern; }

	// AK\ //
	GenericRexp *next;
	int connection;		// 0:AND 1:OR
	bool not;			// ے
};

#endif	// __REXPGEN_H
