#include "file.h"
#pragma hdrstop
#include "tfilebuf.h"
#include "utf.h"

int TTextFileBuffer::read(void *buf, int len)
{
	return ::_tread(fd, buf, len);
}

int TTextFileBufferUTF8::read()
{
	int d;
	// UTF-8
#if !defined(__UTF8)
	if (surrogate){
		wchar_t rc = surrogate;
		surrogate = 0;
		return rc;
	}
#endif
	if (curp+4 >= Size){	// 4 is the maximum length of the UTF-8.
		int r = Size-curp;	// unread bytes.
		if (r>0){
			memmove(Buffer, Buffer+curp, r);
		}
		if ((d = super::read(Buffer+r, Size-r)) <= 0){
			if (curp>=Size){
				return -1;
			} else {
				goto jmp1;	// RoCgȉUTF8ɈႢȂ
			}
		}
		d += r;
		if (d < Size){
			curp = Size - d;
			memmove(Buffer+curp, Buffer, d);
		} else {
			curp = 0;
		}
	}
jmp1:;
#if defined(__UTF8)
	return Buffer[curp++];
#else
	// UTF8 -> UTF16
	const char *next;
	unsigned long uc = UTF8toUTF16((const char*)Buffer+curp, &next);
	// uc includes surrogate
	curp = (int)((char*)next-(char*)Buffer);
	if (uc==0 && curp>=BUFFSIZE){
		return -1;	// end of file
	}
	if (uc>=0x10000){
		surrogate = uc&0xFFFF;
		return (wchar_t)(uc>>16);
	}
	return uc;
#endif
}

void TTextFileBufferUTF16BE::changeEndian()
{
	// endian change
	wchar_t *p = Buffer+curp;
	wchar_t *ep = Buffer+Size;
	for (;p<ep;){
		*p = (p[0]<<8) | (p[0]>>8);
		p++;
	}
}

