#include	"tnlib.h"
#pragma	hdrstop
#include	"file.h"
#include <string>
using namespace std;

#include "tfilebuf.h"

//TODO:
// ܂R[h̒ۉxႢ

TIFile::TIFile()
{
	readbuff = NULL;
	textmode = TFM_DEFAULT;
	bom = 0;	// ANSI or not confirmed
}

TIFile::~TIFile()
{
	if ( readbuff ){
		delete readbuff;
	}
}

int TIFile::open( const tchar* _filename )
{
	filename = _filename;
	text = 1;
	err = 0;
	if ( fd == -1 ){
		fd = ::_topen( filename, O_RDONLY|O_BINARY );
		if (fd == -1){
			err = 1;
			return -1;
		}
	}
	if (readbuff)
		delete readbuff;
#ifdef _UNICODE
	bom = skipmark();
	switch (bom){
		case 0xFEFF:
			readbuff = new TTextFileBufferUTF16(fd, BUFFSIZE);
			textmode = TFM_DEFAULT;
			break;
		case 0xFFFE:
			readbuff = new TTextFileBufferUTF16BE(fd, BUFFSIZE);
			textmode = TFM_UTF16BE;
			break;
		case 0xBF:
			readbuff = new TTextFileBufferUTF8(fd, BUFFSIZE);
			textmode = TFM_UTF8;
			break;
		default:
			readbuff = new TTextFileBufferAnsi(fd, BUFFSIZE);
			textmode = TFM_ANSI;
			break;
	}
#else
	readbuff = new TTextFileBufferAnsi(fd, BUFFSIZE);
#endif
	return 0;
}

void TIFile::flush()
{
	if (!readbuff)
		return;
	readbuff->flush();
}

#ifdef _UNICODE
void TIFile::home( )
{
	seek(0);
	skipmark();
}

// 擪0xFFFE or 0xFEFFƂ΂
// open()̂ݗL
// return value : mark value
// ꍇskipA0Ԃ
unsigned short TIFile::skipmark()
{
	TTextFileBufferAsc buff(fd, 4);
	int c = buff.read() | (buff.read()<<8);
	if ( c == 0xFEFF || c == 0xFFFE){
		seek(2);
		return (unsigned short)c;
	}
	if (c==0xBBEF){
		c = buff.read();
		if (c==0xBF){
			seek(3);
			return (unsigned short)c;	// UTF-8
		}
	}
	if ( c != -1 )
		seek(0);
	return 0;
}
#endif
int TIFile::get( )
{
	return readbuff->read();
#ifdef _UNICODE
#if 0	// moved
	if (bom==0xBF){
		// UTF-8
		if (surrogate){
			wchar_t rc = surrogate;
			surrogate = 0;
			return rc;
		}
		if (curp+4 >= BUFFSIZE){	// 4 is the maximum length of the UTF-8.
			if ((d = _tread(fd, readbuff->get(), BUFFSIZE)) <= 0){
				if (curp>=BUFFSIZE){
					return -1;
				} else {
					goto jmp1;	// RoCgȉUTF8ɈႢȂ
				}
			}
			if (d < BUFFSIZE){
				curp = BUFFSIZE - d;
				memmove((char*)readbuff->get()+curp, readbuff, d);
			} else {
				curp = 0;
			}
		}
	jmp1:;
		// UTF8 -> UTF16
		const char *next;
		unsigned long uc = UTF8toUTF16((const char*)readbuff+curp, &next);
		// uc includes surrogate
		curp = (int)((char*)next-(char*)readbuff);
		if (uc==0 && curp>=BUFFSIZE){
			return -1;	// end of file
		}
		if (uc>=0x10000){
			surrogate = uc&0xFFFF;
			return (wchar_t)(uc>>16);
		}
		return uc;
	}
#endif
#endif	// _UNICODE
#if 0
	if ( curp >= BUFFSIZE ){
		if ((d = BYTETOLEN(_tread(fd, readbuff, LENTOBYTE(BUFFSIZE)))) <= 0)
			return -1;
		if (d < BUFFSIZE){
			curp = BUFFSIZE - d;
			memmove(readbuff+curp, readbuff, LENTOBYTE(d));
		} else {
			curp = 0;
		}
#ifdef _UNICODE
		if (bom == 0xFFFE){
			// endian change
			wchar_t *p = readbuff+curp;
			for ( int i=0;i<d;i++ ){
				*p = (p[0]<<8) | (p[0]>>8);
				p++;
			}
		}
#endif
	}
	return (tuchar)readbuff[curp++];
#endif
}

void TIFile::seek(long l)
{
	if (readbuff){
		readbuff->flush();
	}
	_tlseek(fd, l, SEEK_SET);
}

long TIFile::tell()
{
	return _ttell(fd) - (readbuff ? readbuff->remainBytes() : 0);
}

#ifdef WINCE
inline bool _ismbblead( unsigned char c )
{
	// for ShiftJIS
	return (c>=0x80&&c<=0x9F) || (c>=0xE0 /*&&c<=0xFF*/);
}
#endif	// WINCE

int TIFile::getline( tnstr &buf )
{
#ifdef _UNICODE
	if (!bom){
		return getlineA(buf);
	}
#endif
	tchar fbuf[256];
	tchar *p = fbuf;
	int len = 0;
	buf.clear();
	register int l;
	while ( 1 ){
		int cc = get();
		if ( cc == -1 ){
			l = STR_DIFF(p, fbuf);
			if (l==0){
				return -1;
			} else {
				buf.cat(fbuf, l);
				return len + l;
			}
		}
		tchar c = (tchar)cc;
		if ( c == '\x1a' || c == '\0' )
			continue;
		if ( c == '\r' ){
			cc = get();
			if ( cc != '\n' ){
				readbuff->push_back(cc);
			}
			goto j1;
		}
		if ( c == '\n' ){
j1:
			l = STR_DIFF(p,fbuf);
			buf.cat(fbuf, l);
			return len + l;
		}
		if ( (l=STR_DIFF(p,fbuf)) >= tsizeof(fbuf)-1 ){
			buf.cat(fbuf, l);
			len += l;
			p = fbuf;
		}
		*p++ = c;
	}
}

#if 0
int TIFile::getline( __Char &buf )
{
#ifdef _UNICODE
	if (!bom){
		return getlineA(buf);
	}
#endif
	tchar fbuf[256];
	tchar *p = fbuf;
	int len = 0;
	buf.clear();
	while ( 1 ){
		int cc = get();
		if ( cc == -1 ){
			*p = '\0';
			buf.cat( fbuf );
			if ( buf[0] == '\0' ){
				return -1;
			} else {
				return len + STR_DIFF(p,fbuf);
			}
		}
		tchar c = (tchar)cc;
		if ( c == '\x1a' || c == '\0' )
			continue;
		if ( c == '\r' ){
			cc = get();
			if ( cc != '\n' ){
				readbuff->push_back(cc);
			}
			goto j1;
		}
		if ( c == '\n' ){
j1:
			*p = '\0';
			buf.cat( fbuf );
			return len + STR_DIFF(p,fbuf);
		}
		if ( STR_DIFF(p,fbuf) >= tsizeof(fbuf)-1 ){
			*p = '\0';
			buf.cat( fbuf );
			len += STR_DIFF(p,fbuf);
			p = fbuf;
		}
		*p++ = c;
	}
}

int TIFile::getlineT( __Char &buf )
{
	if ( bom ){
		return getline( buf );
	} else {
		return getlineA( buf );
	}
}
#endif

#if 0	//TODO: not implemented yet
//eLXgt@Cpsǂݍ݃[`
//'\n'܂œǂݍ݁A'\r\n'͎̂Ă
//maxlenz镶͎̂Ăi{̑QoCgʁj
//ԗǂI͕Ԃl-1łAȂbuf[0] == '\0'łꍇ
// 1999.1.6 revised.
// ߂lFǂݍ݃oCg, -1=error or EOF
// 
// UNIX, MacsΉ
int TIFile::getline( tchar *buf, int maxlen )
{
#ifdef _UNICODE
	if (!bom){
		return getlineA(buf, maxlen);	//TODO: not implemented yet
	}
#endif
	tchar *p = buf;
	tchar *lastp = buf + maxlen - 1;
	for (;;){
		int cc = get();
		if ( cc == -1 ){
			p[0] = '\0';
			return buf == p ? -1 : STR_DIFF(p,buf);
		}
		tchar c = (tchar)cc;
		if ( c == '\x1a' || c == '\0' )
			continue;
		if ( c == '\r' ){
			c = (tchar)get();
			if ( c != '\n' ){
				readbuff->push_back(c);
			}
			goto j1;
		}
		if ( c == '\n' ){
	j1:
#ifndef _UNICODE
			if ( p >= lastp ){
				if ( _ismbblead( (unsigned char)*(p-1) ) ){
					if ( _mbsbtype( (const unsigned char*)buf, (int)(p-buf)-1 ) == _MBC_LEAD ){
						p--;
					}
				}
			}
#endif
			*p = '\0';
			return STR_DIFF(p,buf);
		}
		if ( p < lastp ){		//lenȏ͎̂̕Ă
			*p++ = c;
		}
	}
}
#endif

int TIFile::skipline( )
{
	for (;;){
		int cc = get();
		if ( cc == -1 ){
			// EOF
			return -1;
		}
		tchar c = (tchar)cc;
		if ( c == '\x1a' || c == '\0' )
			continue;
		if ( c == '\r' ){
			c = (tchar)get();
			if ( c != '\n' ){
				readbuff->push_back(c);
			}
			// EOL
			return 0;
		}
		if ( c == '\n' ){
			// EOL
			return 0;
		}
	}
}

int TIFile::getA( )
{
	if (bom){
		long loc = tell();
		if (readbuff)
			delete readbuff;
		bom = 0;
		readbuff = new TTextFileBufferAnsi(fd, BUFFSIZE);
		if (!readbuff)
			return -1;
		seek(loc);
	}
	return readbuff->read();
}

#ifdef _UNICODE
// ANSI textǂݍ݁AUNICODEŕԂ
int TIFile::getlineA( tnstr &buf )
{
	string s;
	int r = getline(s);
	if (r==-1)
		return r;
	wchar_t *wbuf = new wchar_t[r+1];
	r = _MultiByteToWideChar( CP_ACP, 0, s.c_str(), r, wbuf, r+1 );
	wbuf[r] = '\0';
	buf.setBuf(wbuf);
	return r;
}

#if 0
// ANSI textǂݍ݁AUNICODEŕԂ
int TIFile::getlineA( __Char &buf )
{
	string s;
	int r = getline(s);
	if (r==-1)
		return r;
	wchar_t *wbuf = new wchar_t[r+1];
	r = _MultiByteToWideChar( CP_ACP, 0, s.c_str(), r, wbuf, r+1 );
	wbuf[r] = '\0';
	buf.SetBuf(wbuf);
	return r;
}
#endif
#endif	// _UNICODE

// ASC/UTF-8 textǂݍ
// No code conversion.
int TIFile::getline( std::string &buf )
{
	char fbuf[256];
	char *p = fbuf;
	int len = 0;
	int r;
	buf = "";
	while ( 1 ){
		int cc = getA();
		switch ( cc ){
			case -1:
				*p = '\0';
				r = (int)(p-fbuf);
				buf += fbuf;
				if ( buf[0] == '\0' ){
					return -1;
				} else {
					return len + r;
				}
			case '\x1a':
			case '\0':
				continue;
			case '\r':
				cc = getA();
				if ( cc != '\n' ){
					readbuff->push_back(cc);
				}
				goto j1;
			case '\n':
j1:
				*p = '\0';
				r = (int)(p-fbuf);
				buf += fbuf;
				return len + r;
			default:
				if ( (int)(p-fbuf) >= sizeof(fbuf)-1 ){
					*p = '\0';
					BYTE c = (BYTE)p[-1];
					if (IsDBCSLeadByte(c)){
						// QoCĝPoCgځi炵j
						char *q = fbuf;
						for(;q<p;){
							if ( _ismbblead(*q) ){
								q += 2;
							} else {
								q++;
							}
						}
						if ( q != p ){
							// ͂p[-1]͂QoCĝPoCgڂ
							p--;
							p[0] = '\0';
						} else {
							c = 0;
						}
					} else {
						c = 0;
					}
					buf += fbuf;
					r = (int)(p-fbuf);
					len += r;
					p = fbuf;
					if (c)
						*p++ = (char)c;
				}
				*p++ = (char)cc;
				break;
		}
	}
}

bool TIFile::createFixedTextBuffer(int buffsize)
{
	if (readbuff)
		delete readbuff;
	readbuff = new TTextFileBufferT<tchar>(0, buffsize);
	if (!readbuff)
		return false;
	return true;
}
