#include "tnlib.h"
#pragma hdrstop
#include "tnstr.h"

/// __tnstrA ///
__tnstrA::__tnstrA(const wchar_t *s, bool utf8)
{
	if (utf8){
		setUTF8(s);
	} else {
		setAnsi(s);
	}
}

#if 0
int __tnstrA::find(const char*pat)
{
	if (!buf)
		return -1;
	char *p = strstr(buf, pat);
	if (!p)
		return -1;
	return (int)(p-buf);
}
#endif

#if 0
bool __tnstrA::LoadString(int id)
{
	//TODO: œKload@T
	static bool mutex = false;	// easy mutex for buf_LoadString
	for (;mutex;){ Sleep(1); }
	mutex = true;
	int size = ::LoadStringA(hTNInstance, id, buf_LoadString, sizeof(buf_LoadString)/sizeT);
	if (size==0){
		mutex = false;
		return false;
	}
	if (buf) delete[] buf;
	buf = new char[size+1];
	if (!buf){
		mutex = false;
		return false;
	}
	strcpy(buf, buf_LoadString);
	mutex = false;
	return true;
}
#endif

// Code Conversion //
// UTF16 >> UTF8
void __tnstrA::setUTF8(const wchar_t *utf16, int utf16_len)
{
	if (!utf16 || utf16_len==0){
		clear();
		return;
	}
	if (utf16_len<0){
		utf16_len = wcslen(utf16);
	}
	char *buf_new = new char[utf16_len*4+1];
	if (!buf_new)
		return;	// error
	UTF16toUTF8(utf16, utf16_len, buf_new);
	if (buf){
		delete[] buf;
	}
	buf = buf_new;
}

// UTF16 >> ANSI
void __tnstrA::setAnsi(const wchar_t *utf16, int utf16_len)
{
	if (!utf16 || utf16_len==0){
		clear();
		return;
	}
	if (utf16_len<0){
		utf16_len = wcslen(utf16);
	}
	int buf_size = utf16_len*2+1;
	char *buf_new = new char[buf_size];
	if (!buf_new)
		return;	// error
	int ret = WideCharToMultiByte(CP_ACP, 0, utf16, utf16_len, buf_new, buf_size, NULL, NULL );
	if (ret==0){
		delete[] buf_new;
		return;	// error
	}
	buf_new[ret] = '\0';
	if (buf){
		delete[] buf;
	}
	buf = buf_new;
}

__tnstrW __tnstrA::getWUTF8()
{
	__tnstrW ret;
	ret.setUTF8(*this);
	return ret;
}
__tnstrW __tnstrA::getWAnsi()
{
	__tnstrW ret;
	ret.setAnsi(*this);
	return ret;
}

#if 0
#if !defined(__UTF8)
__tnstrA __tnstrA::getUTF8()
{
	//TODO: 2iKϊ
	__tnstrW strw;
	strw.setAnsi(c_str());
	__tnstrA stra;
	stra.setUTF8(strw);
	return stra;
}
#endif
#endif

/// __tnstrW ///
__tnstrW::__tnstrW(const char *s1, bool utf8)
{
	if (utf8){
		setUTF8(s1);
	} else {
		setAnsi(s1);
	}
}
int __tnstrW::find(const wchar_t*pat)
{
	if (!buf)
		return -1;
	wchar_t *p = wcsstr(buf, pat);
	if (!p)
		return -1;
	return (int)(p-buf);
}

#if 0
bool __tnstrW::LoadString(int id)
{
	//TODO: œKload@T
	static bool mutex = false;	// easy mutex for buf_LoadString
	for (;mutex;){ Sleep(1); }
	mutex = true;
	int size = ::LoadStringW(hTNInstance, id, buf_LoadString, sizeof(buf_LoadString)/sizeT);
	if (size==0){
		mutex = false;
		return false;
	}
	if (buf) delete[] buf;
	buf = new wchar_t[size+1];
	if (!buf){
		mutex = false;
		return false;
	}
	wcscpy(buf, buf_LoadString);
	mutex = false;
	return true;
}
#endif

// Code Conversion //
// UTF-8 >> UTF-16
// utf8_len is byte unit.
void __tnstrW::setUTF8(const char *utf8, int utf8_len)
{
	if (!utf8 || utf8_len==0){
		clear();
		return;
	}
	if (utf8_len<0){
		utf8_len = strlen(utf8);
	}
	wchar_t *buf_new = new wchar_t[utf8_len*2+1];
	if (!buf_new)
		return;	// error
	UTF8toUTF16(utf8, utf8_len, buf_new);
	if (buf){
		delete[] buf;
	}
	buf = buf_new;
}

// ANSI >> UTF16
void __tnstrW::setAnsi(const char *ansi, int ansi_len)
{
	if (!ansi || ansi_len==0){
		clear();
		return;
	}
	if (ansi_len<0){
		ansi_len = strlen(ansi);
	}
	int buf_len = ansi_len*2;
	wchar_t *buf_new = new wchar_t[buf_len+1];
	if (!buf_new)
		return;	// error
	int wlen = MultiByteToWideChar(CP_ACP, 0, ansi, ansi_len, buf_new, buf_len);
	buf_new[wlen] = '\0';
	if (buf){
		delete[] buf;
	}
	buf = buf_new;
}

#if 0
// UTF16 >> UTF8
__tnstrA __tnstrW::getUTF8()
{
	__tnstrA stra;
	stra.setUTF8(c_str());
	return stra;
}
#endif

// VCL depends.
#include <StdCtrls.hpp>

/// __tnstrA ///
__tnstrA::operator System::AnsiString () const
{
	return AnsiString(c_str());
}

__tnstrA tnsprintfA(const char *fmt, ...)
{
	va_list(ap);
	va_start(ap, fmt);
	__tnstrA ret = _tnsprintfA(fmt, ap);
	va_end(ap);
	return ret;
}

__tnstrA _tnsprintfA(const char *fmt, va_list arg)
{
	char abuf[256];
	char *buf = NULL;
	int nsize = sizeof(abuf);
	int rsize = vsnprintf(abuf, nsize-1, fmt, arg);
	if (rsize>=nsize-1){
		nsize = vsnprintf(NULL, 0, fmt, arg)+1;
		buf = new char[nsize];
		if (buf){
			vsnprintf(buf, nsize, fmt, arg);
		} else {
			abuf[0] = '\0';
		}
	}
	if (buf){
		auto_ptr<char> _buf(buf);
		return __tnstrA(buf);
	} else {
		return __tnstrA(abuf);
	}
}

/// __tnstrW ///
__tnstrW::operator System::WideString () const
{
	return WideString(buf ? buf : buf_null);
}

__tnstrW &__tnstrW::operator = (const System::WideString &ws)
{
	set(ws.c_bstr());
	return *this;
}

__tnstrW tnsprintfW(const wchar_t *fmt, ...)
{
	va_list(ap);
	va_start(ap, fmt);
	__tnstrW ret = _tnsprintfW(fmt, ap);
	va_end(ap);
	return ret;
}

__tnstrW _tnsprintfW(const wchar_t *fmt, va_list arg)
{
#if 0
	wchar_t abuf[1025];
	wvsprintf(abuf, fmt, arg);
	return __tnstrW(abuf);
#else
	wchar_t abuf[256];
	wchar_t *buf = NULL;
	int nsize = sizeof(abuf)/sizeof(wchar_t);
	int rsize = vsnwprintf(abuf, nsize-1, fmt, arg);
	if (rsize>=nsize-1){
		nsize = vsnwprintf(NULL, 0, fmt, arg)+1;
		buf = new wchar_t[nsize];
		if (buf){
			vsnwprintf(buf, nsize, fmt, arg);
		} else {
			abuf[0] = '\0';
		}
	}
	if (buf){
		auto_ptr<wchar_t> _buf(buf);
		return __tnstrW(buf);
	} else {
		return __tnstrW(abuf);
	}
#endif
}

