#include "uustr.h"
#include "utf.h"

uustr::uustr( const char *str )
{
	constructor(str, str ? strlen(str) : 0);
}
uustr::uustr( const wchar_t *str )
{
	constructor(str, str ? wcslen(str) : 0);
}
void uustr::constructor(const char *str, int len)
{
	buffer = (void*)str;
	length = len;
	type = 1;
	newbuffer = NULL;
}
void uustr::constructor(const wchar_t *str, int len)
{
	buffer = (void*)str;
	length = len;
	type = 2;
	newbuffer = NULL;
}
uustr::~uustr()
{
	if ( newbuffer ) delete[] newbuffer;
}
uustr::operator char *()
{
	if ( type == 1 ) return (char*)buffer;
	if ( newbuffer ) return (char*)newbuffer;

	// UTF16 to UTF8

	newbuffer = new char[ length*4 + 1 ];
	UTF16toUTF8((wchar_t*)buffer, length, newbuffer);
	return (char*)newbuffer;
}
uustr::operator wchar_t *()
{
	if ( type == 2 ) return (wchar_t*)buffer;
	if ( newbuffer ) return (wchar_t*)newbuffer;

	// UTF8 to UTF16

	*(wchar_t**)&newbuffer = new wchar_t[ length*4 + 1 ];
	UTF8toUTF16((char*)buffer, length, (wchar_t*)newbuffer);
	return (wchar_t*)newbuffer;
}

